VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGraphicEnhancement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lastNodeEnhanced As afNode

Public Sub MagnifyEmptyTransition(grafo As AddFlow)
    Dim f As Single
    Dim bHasChanged As Boolean
    
    'If the mouse point a empty transition we'll enhaced it to improve the edition
    With grafo
        If LenB(.PointedNode.Text) = 0 Then
            bHasChanged = .IsChanged
            f = .PointedNode.Left - MIN_NODE_WIDTH_d2
            .PointedNode.Left = IIf(f > 0, f, 0)
            f = .PointedNode.top - MIN_NODE_HEIGHT_d2
            .PointedNode.top = IIf(f > 0, f, 0)
            .PointedNode.Width = MIN_NODE_WIDTH_p2
            .PointedNode.Height = MIN_NODE_HEIGHT_p2
            Set lastNodeEnhanced = .PointedNode
            .SetChangedFlag bHasChanged
        End If
    End With
End Sub

Public Sub UnMagnifyEmptyTransition(grafo As AddFlow)
    'If a empty transition was enhaced now will return it to normal size
    Dim bHasChanged As Boolean
    If Not (lastNodeEnhanced Is Nothing) Then
        bHasChanged = grafo.IsChanged
        With lastNodeEnhanced
            On Error Resume Next
            .Width = MIN_NODE_WIDTH
            .Height = MIN_NODE_HEIGHT
            .Left = .Left + MIN_NODE_WIDTH_d2
            .top = .top + MIN_NODE_HEIGHT_d2
            On Error GoTo 0
        End With
        Set lastNodeEnhanced = Nothing
        grafo.SetChangedFlag bHasChanged
    End If
End Sub

'Limita el tamao mnimo de los nodos
Public Sub LimitMinimSize(nodo As afNode)
    If nodo.Width < MIN_NODE_WIDTH Then
        nodo.Width = MIN_NODE_WIDTH
    End If
    If nodo.Height < MIN_NODE_HEIGHT Then
        nodo.Height = MIN_NODE_HEIGHT
    End If
End Sub

Public Sub AdjustSize(nodo As afNode)
Dim bHasChanged As Boolean
Dim activeFrmDoc As frmDoc
    Set activeFrmDoc = mainFrm.ActiveForm
    bHasChanged = activeFrmDoc.AddFlow1.IsChanged
    If EsTransicion(nodo) Then
        If LenB(nodo.Text) = 0 Then
            nodo.Height = MIN_NODE_HEIGHT
            nodo.Width = MIN_NODE_WIDTH
        Else
            nodo.AutoSize = afAdjustNodeSizetoText
            nodo.AutoSize = afNoAutoSize
            nodo.Height = nodo.Height + 50
            nodo.Width = nodo.Width + 50
        End If
    ElseIf activeFrmDoc.mnuAutosizeNodes.Checked Then
        nodo.AutoSize = afAdjustNodeSizetoText
        nodo.AutoSize = afNoAutoSize
        nodo.Height = nodo.Height + 15
        nodo.Width = nodo.Width + 15
    End If
    activeFrmDoc.AddFlow1.SetChangedFlag bHasChanged
End Sub

'Reajusta todos tamaos de todos nodos (especial en caso de zooms)
Public Sub AdjustAllNodeSizes(grafo As AddFlow)
Dim nodo As afNode
    'Busca todos los nodos reajustables
    For Each nodo In grafo.Nodes
        'Reajusta el tamao del nodo
        AdjustSize nodo
    Next
End Sub


Public Sub OrtogonalizeLinks(points As afLinkPoints)
Dim lp As afLinkPoint
Dim numCorrections As Long

Dim activeFrmDoc As frmDoc
    Set activeFrmDoc = mainFrm.ActiveForm

    If points.count = 3 Then
        numCorrections = 0
        activeFrmDoc.AddFlow1.Repaint = False
        Set lp = points.Item(1)
        If Abs(points.Item(0).x - points.Item(1).x) < MIN_TO_ADJUST_POLYLINE Then
            lp.x = points.Item(0).x
            numCorrections = 1
        End If
        If Abs(points.Item(0).y - points.Item(1).y) < MIN_TO_ADJUST_POLYLINE Then
            lp.y = points.Item(0).y
            numCorrections = numCorrections + 1
        End If
        If numCorrections = 1 Then
            Set points.Item(1) = lp
        End If
        activeFrmDoc.AddFlow1.Repaint = True

        numCorrections = 0
        activeFrmDoc.AddFlow1.Repaint = False
        Set lp = points.Item(1)
        If Abs(points.Item(2).x - points.Item(1).x) < MIN_TO_ADJUST_POLYLINE Then
            lp.x = points.Item(2).x
            numCorrections = 1
        End If
        If Abs(points.Item(2).y - points.Item(1).y) < MIN_TO_ADJUST_POLYLINE Then
            lp.y = points.Item(2).y
            numCorrections = numCorrections + 1
        End If
        If numCorrections = 1 Then
            Set points.Item(1) = lp
        End If
        activeFrmDoc.AddFlow1.Repaint = True
    
    End If

End Sub


Public Sub OrtogonalizeTransitions(node As afNode)
Dim tmp As Single
Dim nodeOri  As afNode
Dim nodeDst  As afNode
Dim nodeTmp  As afNode

Dim numCorrections As Long
Dim activeFrmDoc As frmDoc
    Set activeFrmDoc = mainFrm.ActiveForm

    Set nodeOri = node.InLinks(1).org
    Set nodeDst = node.OutLinks(1).dst

    numCorrections = 0
    activeFrmDoc.AddFlow1.Repaint = False
    Set nodeTmp = node
    If Abs((node.Left + node.Width / 2) - (nodeOri.Left + nodeOri.Width / 2)) < MIN_TO_ADJUST_POLYLINE Then
        tmp = nodeOri.Left + ((nodeOri.Width - node.Width) / 2)
        nodeTmp.Left = IIf(tmp > 0, tmp, 0)
        numCorrections = 1
    End If
    If Abs((node.top + node.Height / 2) - (nodeOri.top + nodeOri.Height / 2)) < MIN_TO_ADJUST_POLYLINE Then
        tmp = nodeOri.top + ((nodeOri.Height - node.Height) / 2)
        nodeTmp.top = IIf(tmp > 0, tmp, 0)
        numCorrections = numCorrections + 1
    End If
    If numCorrections = 1 Then
        Set node = nodeTmp
    End If
    activeFrmDoc.AddFlow1.Repaint = True
    
    numCorrections = 0
    activeFrmDoc.AddFlow1.Repaint = False
    Set nodeTmp = node
    If Abs((node.Left + node.Width / 2) - (nodeDst.Left + nodeDst.Width / 2)) < MIN_TO_ADJUST_POLYLINE Then
        tmp = nodeDst.Left + ((nodeDst.Width - node.Width) / 2)
        nodeTmp.Left = IIf(tmp > 0, tmp, 0)
        numCorrections = 1
    End If
    If Abs((node.top + node.Height / 2) - (nodeDst.top + nodeDst.Height / 2)) < MIN_TO_ADJUST_POLYLINE Then
        tmp = nodeDst.top + ((nodeDst.Height - node.Height) / 2)
        nodeTmp.top = IIf(tmp > 0, tmp, 0)
        numCorrections = numCorrections + 1
    End If
    If numCorrections = 1 Then
        Set node = nodeTmp
    End If
    activeFrmDoc.AddFlow1.Repaint = True

End Sub

