Attribute VB_Name = "modNodoEstado"
Option Explicit

Private enhancegr            As New clsGraphicEnhancement

Public Enum enumParamEstado
    ESTADO_NAME
    ACTIONS_MOORE
    ESTADO_INDICE
    ACTIONS_ENTRY
    ACTIONS_EXIT
    FUNCTION_IS_IN
    FUNCTION_GO_TO
    ACTIONS_ELSE
End Enum

Public Function EsEstado(nodo As afNode) As Boolean
    EsEstado = nodo.UserData And NODO_ESTADO
End Function
Public Function EsEstadoInicial(nodo As afNode) As Boolean
    EsEstadoInicial = nodo.UserData And NODO_ESTADO_INICIAL
End Function
Public Function EsEstadoFinal(nodo As afNode) As Boolean
    EsEstadoFinal = nodo.UserData And NODO_ESTADO_FINAL
End Function
Public Function DameNuevoIndiceDeEstado(grafo As AddFlow) As String
Dim nodo As afNode
Dim maxInd As Long
Dim ind As Long

    'Busca el ndice ms alto existente
    maxInd = 0
    If grafo.Nodes.count > 0 Then
        For Each nodo In grafo.Nodes
            If EsEstado(nodo) Then
                ind = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
                If ind > maxInd Then
                    maxInd = ind
                End If
            End If
        Next
    End If
    DameNuevoIndiceDeEstado = Format$(maxInd + 1)
End Function

'Extrae la informacin del nodo de estado
Public Function DimeDatoEstado(posicion As enumParamEstado, nodo As afNode) As String
'Dim campo(0 To 2) As String

'    ExtraeTodosCampos campo(), nodo.Tag
'    DimeDatoEstado = campo(posicion)
    
    DimeDatoEstado = ExtraeCampo(nodo.Tag, posicion)
End Function

Private Function BuscaOtroEstadoDeEsteTipo(modoEstado As enumTipoNodo, nodoNuevo As afNode) As afNode
Dim nodo As afNode
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    'Busca la prioridad ms baja existente
    For Each nodo In grafo.Nodes
        If nodo.UserData And modoEstado Then
            If Not (nodo Is nodoNuevo) Then
                Set BuscaOtroEstadoDeEsteTipo = nodo
                Exit Function
            End If
        End If
    Next
    
    Set BuscaOtroEstadoDeEsteTipo = Nothing

End Function

Public Sub Configura_Nodo_Estado(nombre As String, _
                                 accionMoore As String, _
                                 accionInput As String, _
                                 accionOutput As String, _
                                 accionElse As String, _
                                 indice As String, _
                                 modoEstado As enumTipoNodo, _
                                 funcIsIn As String, _
                                 funcGoTo As String, _
                                 nodo As afNode)
Dim anonimos As Long
Dim nodoDegradado As afNode
Dim s As String
Dim centro As tipoCoordenada
    
    'Memoriza el centro del nodo de estado
    centro.y = nodo.top + nodo.Height / 2
    centro.x = nodo.Left + nodo.Width / 2
    
    If LenB(nombre) = 0 Then
        Do
            anonimos = anonimos + 1
            nombre = "STATE_" & Format$(anonimos)
        Loop Until NombreNodoValido(nombre)
    End If
    
    nodo.UserData = modoEstado
    
    s = Chr$(183) & nombre & Chr$(183) & vbNewLine
'    s = " " & nombre & " " & vbNewLine
    If LenB(accionInput) > 0 Then
        s = s & "#entry:" & vbNewLine
        s = s & FiterAndMakeTxtState(accionInput, 1)
        If LenB(accionMoore) > 0 Then s = s & "#during:" & vbNewLine
                                           
    End If
    If LenB(accionMoore) > 0 Then
        s = s & FiterAndMakeTxtState(accionMoore, 1)
    End If
    If LenB(accionElse) > 0 Then
        s = s & "#else:" & vbNewLine
        s = s & FiterAndMakeTxtState(accionElse, 1)
    End If
    If LenB(accionOutput) > 0 Then
        s = s & "#exit:" & vbNewLine
        s = s & FiterAndMakeTxtState(accionOutput, 1)
    End If
    nodo.Text = s
    
    nodo.Tag = nombre & SEPARADOR & _
               accionMoore & SEPARADOR & _
               indice & SEPARADOR & _
               accionInput & SEPARADOR & _
               accionOutput & SEPARADOR & _
               funcIsIn & SEPARADOR & _
               funcGoTo & SEPARADOR & _
               accionElse & SEPARADOR

    
    nodo.key = nombre & "  (" & indice & ")"
    'Reajusta el tamao del nodo
    Call enhancegr.AdjustSize(nodo)
    'Limita el tamao mnimo de los nodos
    Call enhancegr.LimitMinimSize(nodo)
    
'    nodo.ZOrder = False    'Delante  (Cuidado: Altera los for each)

    If modoEstado And NODO_ESTADO_INICIAL Then
        nodo.DrawWidth = 2
        'nodo.DrawColor = RGB(196, 0, 0)
        ActualizaNodoInicial nodo
        Set nodoDegradado = BuscaOtroEstadoDeEsteTipo(NODO_ESTADO_INICIAL, nodo)
        If Not (nodoDegradado Is Nothing) Then
            RemoveNodoInicialHist nodoDegradado
            nodoDegradado.UserData = NODO_ESTADO_NORMAL
            nodoDegradado.DrawWidth = 1
            nodoDegradado.DrawColor = vbBlue
            nodoDegradado.Shape = afAlternateProcess
        End If
    ElseIf modoEstado And NODO_ESTADO_FINAL Then
        nodo.DrawWidth = 2
        nodo.DrawColor = RGB(128, 128, 64)
        nodo.Shape = afProcess
    ElseIf modoEstado And NODO_ESTADO_PADRE Then
        nodo.UserData = NODO_ESTADO_PADRE
        nodo.DrawWidth = 2
        nodo.DrawColor = vbBlue
        nodo.Shape = afAlternateProcess
    ElseIf modoEstado And NODO_ESTADO_NORMAL Then
        nodo.UserData = NODO_ESTADO_NORMAL
        nodo.DrawWidth = 1
        nodo.DrawColor = vbBlue
        nodo.Shape = afAlternateProcess
    Else
        MsgBox "Error in Configura_Nodo_Estado"
        End
    End If
    
    'Centra de nuevo el nodo
    centro.x = centro.x - nodo.Width / 2
    centro.y = centro.y - nodo.Height / 2
    nodo.Left = IIf(centro.x > 0, centro.x, 1)
    nodo.top = IIf(centro.y > 0, centro.y, 1)
End Sub
'Normaliza los ndices de los nodos de un grafo
'Tiene preferencia el nodo seleccionado
Public Sub Normaliza_Indices(grafo As AddFlow, selNode As afNode)
Dim nodo As afNode
Dim ind As Long
Dim minInd As Long
Dim indNodoSelecc As Long
Dim i As Long
Dim nodoMin As afNode
    
    If selNode Is Nothing Then
        indNodoSelecc = MAX_LONG
    Else
        indNodoSelecc = Val(DimeDatoEstado(ESTADO_INDICE, selNode))
    End If
    
    If grafo.Nodes.count = 0 Then Exit Sub

    grafo.Repaint = False
    Do
        minInd = MAX_LONG
        'Busca el ndice ms bajo existente
        For Each nodo In grafo.Nodes
            If EsEstado(nodo) Then
                If (nodo.UserData And NODO_OFF) = 0 Then
                    ind = Val(DimeDatoEstado(ESTADO_INDICE, nodo))
                    If ind < minInd Then
                        minInd = ind
                        Set nodoMin = nodo
                    End If
                End If
            End If
        Next
        'Comprueba que se haya encontrado algn elemento
        If minInd = MAX_LONG Then Exit Do

        'Da preferencia al nodo de transicin seleccionado
        If minInd = indNodoSelecc Then
            If ((selNode.UserData And NODO_OFF) = 0) And Not (nodoMin Is selNode) Then
                Set nodoMin = selNode
            End If
        End If
        'Asigna la prioridad correspondiente
        i = i + 1
        Configura_Nodo_Estado DimeDatoEstado(ESTADO_NAME, nodoMin), _
                              DimeDatoEstado(ACTIONS_MOORE, nodoMin), _
                              DimeDatoEstado(ACTIONS_ENTRY, nodoMin), _
                              DimeDatoEstado(ACTIONS_EXIT, nodoMin), _
                              DimeDatoEstado(ACTIONS_ELSE, nodoMin), _
                              Format$(i), _
                              nodoMin.UserData, _
                              DimeDatoEstado(FUNCTION_IS_IN, nodoMin), _
                              DimeDatoEstado(FUNCTION_GO_TO, nodoMin), _
                              nodoMin

        nodoMin.UserData = nodoMin.UserData Or NODO_OFF      'Elimina de la coleccin
    Loop
        
    'Restaura el indicador Tag
    For Each nodo In grafo.Nodes
        If nodo.UserData And NODO_OFF Then
            nodo.UserData = nodo.UserData And (Not NODO_OFF)
        End If
    Next
    grafo.Repaint = True
End Sub


'Comprueba si el nombre propuesto ya esta siendo utilizado
Public Function NombreNodoValido(nombre As String) As Boolean
Dim nodo As afNode
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            If Not nodo Is grafo.SelectedNode Then
                If UCase$(nombre) = UCase$(DimeDatoEstado(ESTADO_NAME, nodo)) Then
                    NombreNodoValido = False
                    Exit Function
                End If
            End If
        End If
    Next
    NombreNodoValido = True
End Function


'Busca subcadena en todos Nodos
Public Function RastreaSubcadenaEnEstados(subCadena As String, sAReemplazar As String, caseSensitive As Boolean) As Boolean
Dim nodo As afNode
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            grafo.SelectedNode = nodo
            If frmPropNodo.Buscar(subCadena, sAReemplazar, caseSensitive) = False Then Exit For
        End If
    Next
    RastreaSubcadenaEnEstados = True
End Function


'Actualiza formato de nodo inicial
Public Sub ActualizaNodoInicial(Optional nodo As afNode = Nothing)
Dim activeFrmDoc As frmDoc
    Set activeFrmDoc = mainFrm.ActiveForm
    If nodo Is Nothing Then
        For Each nodo In activeFrmDoc.AddFlow1.Nodes
            If EsEstadoInicial(nodo) Then
                Exit For
            End If
        Next
    End If
    If Not (nodo Is Nothing) Then
    nodo.Shape = afProcess
    
        If activeFrmDoc.bHistoryFsm Then
            nodo.DrawColor = RGB(180, 0, 60)
            If InStr(nodo.Text, HIST_MARK) <> 1 Then
                nodo.Text = HIST_MARK & nodo.Text
            End If
            'Reajusta el tamao del nodo
            Call enhancegr.AdjustSize(nodo)
        Else
            RemoveNodoInicialHist nodo
            nodo.DrawColor = RGB(230, 0, 0)
        End If
    End If
End Sub


Public Sub RemoveNodoInicialHist(nodo As afNode)
    If Left$(nodo.Text, Len(HIST_MARK)) = HIST_MARK Then
        nodo.Text = Mid$(nodo.Text, Len(HIST_MARK) + 1)
        'Reajusta el tamao del nodo
        Call enhancegr.AdjustSize(nodo)
        'Limita el tamao mnimo de los nodos
        Call enhancegr.LimitMinimSize(nodo)
    End If
End Sub


'Repaint all states
Public Sub RepaintStates()
Dim nodo As afNode
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
'    grafo.FillColor = defaultFillColor
'    grafo.ForeColor = defaultForeColor
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            nodo.FillColor = grafo.FillColor
            nodo.ForeColor = grafo.ForeColor
        End If
    Next
End Sub


