VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsParientes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lista() As String
Private indLista As Long

Private Type tipoRutasPosibles
    hijos As String
    hijosRel As String
    padre As String
End Type
Private ruta As tipoRutasPosibles

Private Sub Class_Initialize()
    Reset
End Sub

Public Sub Reset()
Dim activeFrmDoc As frmDoc
    indLista = 0
    ReDim lista(0 To 0) As String   'Atencin: la lista(0) es un centinela = vbnullstring
    Set activeFrmDoc = mainFrm.ActiveForm
    BuscaRutas activeFrmDoc
End Sub

Public Function DimeHijo(index As Long) As String
    If index >= 1 And index <= indLista Then
        DimeHijo = lista(index)
    Else
        DimeHijo = vbNullString
    End If
End Function

Public Function DimeNumeroHijos() As Long
    DimeNumeroHijos = indLista
End Function

Public Function RutaCompleta(file As String) As String
    If Left$(file, 1) = "\" Then
        RutaCompleta = ruta.hijos & file
    Else
        RutaCompleta = ruta.padre & "\" & file
    End If
End Function

Public Function RutaRelativa(file As String) As String
    If Left$(file, 1) = "\" Then
        RutaRelativa = ruta.hijosRel & file
    Else
        RutaRelativa = ".\" & file
    End If
End Function


Private Sub BuscaRutas(frm As frmDoc)
Dim s As String
    
    ruta.hijosRel = vbNullString
    ruta.padre = vbNullString
    'Elimina la extension al nombre del padre
    '  c:\windows\system\xxx.flw --> c:\windows\system\xxx
    s = FileSinExtension(frm.sFullDocname)
    If LenB(s) > 0 Then
                
        'Busca el nombre del padre como directorio relativo
        '  c:\windows\system\xxx --> .\xxx
        ruta.hijosRel = ".\" & FileSinRuta(s)
        
        'Convierte rutas relativas en absolutas
        '  c:\windows\system\xxx --> c:\windows\system\xxx
        '  .\xxx --> c:\windows\system\xxx
        '  \xxx --> c:\windows\system\xxx
        '  xxx --> c:\windows\system\xxx
        ruta.hijos = FileConRuta(s)
        
        'Busca la ruta del padre
        '  c:\windows\system\xxx --> c:\windows\system
        ruta.padre = RutaSinFile(ruta.hijos)
    End If
End Sub
Public Function BuscaTodosEnlaces(grafo As AddFlow) As Boolean
Dim nodo As afNode
Dim r As Boolean
    'Busca hijos en nodos
    r = False
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            r = r Or BuscaEnlaces(DimeDatoEstado(ACTIONS_MOORE, nodo)) Or _
                     BuscaEnlaces(DimeDatoEstado(ACTIONS_ELSE, nodo))
        End If
    Next
    'Busca hijos en zona comn
'    r = r Or BuscaEnlaces(DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo)) Or _
'             BuscaEnlaces(DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo))
    BuscaTodosEnlaces = r
End Function

Public Function BuscaEnlaces(sTexto As String) As Boolean
Dim i As Long
Dim c As String
Dim sFuncion As String
    BuscaEnlaces = False
    
    'Seek only functions
    sTexto = " " & sTexto
    sFuncion = vbNullString
    For i = Len(sTexto) To 1 Step -1
        'Lee el siguiente char por la derecha
        c = Mid$(sTexto, i, 1)
        
        'Append char until the end of the name
        If (c >= "A" And c <= "Z") Or (c >= "a" And c <= "z") Or (c >= "0" And c <= "9") Or c = "_" Then 'Por la Dcha encuentra 1 el LineFeed
            sFuncion = c + sFuncion
        Else
            If LenB(sFuncion) Then
                'Check if the function name is valid
                c = Left$(sFuncion, 1)
                If Not (c >= "0" And c <= "9") Then
                    sFuncion = sFuncion & ".fsm"
                    If FileExistCS(ruta.padre & "\" & sFuncion, vbNormal + vbReadOnly) Then
                        AnnadeOrdenadoSiNuevo sFuncion
                        BuscaEnlaces = True
                    End If
                    If FileExistCS(ruta.hijos & "\" & sFuncion, vbNormal + vbReadOnly) Then
                        sFuncion = "\" & sFuncion
                        AnnadeOrdenadoSiNuevo sFuncion
                        BuscaEnlaces = True
                    End If
                End If
                sFuncion = vbNullString
            End If
        End If
    Next
End Function

#If 0 Then
    Private Sub AnnadeSiNuevo(dato As String)
    Dim i As Long
        For i = 1 To indLista
            If lista(i) = dato Then Exit For
        Next
        If i > indLista Then
            indLista = indLista + 1
            ReDim Preserve lista(0 To indLista) As String
            lista(indLista) = dato
        End If
    End Sub
#End If

Private Sub AnnadeOrdenadoSiNuevo(dato As String)
Dim i As Long
Dim j As Long

    For i = 0 To indLista
        If dato <= lista(i) Then
            If dato < lista(i) Then
                'Amplia la matriz
                indLista = indLista + 1
                ReDim Preserve lista(0 To indLista) As String
                'Crea un hueco
                For j = indLista To i + 1 Step -1
                    lista(j) = lista(j - 1)
                Next
                'Inserta el nuevo dato
                lista(i) = dato
            End If
            Exit Sub
        End If
    Next
    'Si no se puede insertar lo aade al final
    indLista = indLista + 1
    ReDim Preserve lista(0 To indLista) As String
    lista(indLista) = dato
End Sub

