Attribute VB_Name = "modLib_Rutas"
Option Explicit

Private Declare Function GetTempPath Lib "kernel32.dll" _
        Alias "GetTempPathA" (ByVal nBufferLength As Long, _
        ByVal lpBuffer As String) As Long

'::--------------------------------------------------------------::
'Task: Create a multi-level directory structure using
'CreateDirectory API call Declarations
'::--------------------------------------------------------------::
Private Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type
Private Declare Function CreateDirectory Lib "kernel32" Alias "CreateDirectoryA" (ByVal lpPathName As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
'::--------------------------------------------------------------::
        


Public Function SystemTempPath() As String
Const MAX_SIZE  As Long = 260   ' Is a limit fixed by "stdlib.h"
Dim sTmpFolder  As String
Dim size        As Integer

    sTmpFolder = Space(MAX_SIZE)
    size = GetTempPath(MAX_SIZE, sTmpFolder)
    If 0 < size And size < MAX_SIZE Then
        'TempPath = Left$(sTmpFolder, InStr(sTmpFolder, vbNullChar) - 1)
        SystemTempPath = Left$(sTmpFolder, size)
    Else
        SystemTempPath = "c:\"
    End If
End Function

Public Sub CreateNewDirectory(NewDirectory As String)
   Dim SecAttrib As SECURITY_ATTRIBUTES
   Dim sPath As String
   Dim iCounter As Integer
   Dim sTempDir As String

   sPath = NewDirectory

   If Right$(sPath, 1) <> "\" Then
      sPath = sPath & "\"
   End If

   iCounter = 1
   Do While InStr(iCounter, sPath, "\")
      iCounter = InStr(iCounter, sPath, "\")
      sTempDir = Left$(sPath, iCounter)
      iCounter = iCounter + 1
      'create directory
      SecAttrib.lpSecurityDescriptor = &O0
      SecAttrib.bInheritHandle = False
      SecAttrib.nLength = Len(SecAttrib)
      CreateDirectory sTempDir, SecAttrib
   Loop
End Sub

' Elimina la ruta y la extensin
' For instance: c:\windows\system\xxx.flw --> xxx
Public Function FileSinRutaNiExtension(sPathFile As String) As String
    Dim sFile As String
    Dim length2 As Long, length1 As Long
    
    length1 = InStrRev(sPathFile, "\")
    length2 = InStrRev(sPathFile, ".")
    sFile = Right$(sPathFile, Len(sPathFile) - length1)
    If length2 Then
        FileSinRutaNiExtension = Left$(sFile, length2 - length1 - 1)
    Else
        FileSinRutaNiExtension = sFile
    End If
End Function

' Elimina la ruta
' Ejemplo: c:\windows\system\xxx.flw --> xxx.flw
Public Function FileSinRuta(sPathFile As String) As String
    FileSinRuta = Right$(sPathFile, Len(sPathFile) - InStrRev(sPathFile, "\"))
End Function

' Elimina la file
' Ejemplo: c:\windows\system\xxx.flw --> c:\windows\system
Public Function RutaSinFile(sPathFile As String) As String
Dim pos As Long
    pos = InStrRev(sPathFile, "\")
    If pos > 4 Then
        pos = pos - 1
    ElseIf (InStrRev(sPathFile, ":") = 0) And (pos > 0) Then
        pos = pos - 1
    End If
    RutaSinFile = Left$(sPathFile, pos)
End Function

' Elimina la extensin.
' For instance: c:\windows\system\xxx.flw --> c:\windows\system\xxx
Public Function FileSinExtension(sPathFile As String) As String
    Dim length As Long
    length = InStrRev(sPathFile, ".")
    If length Then length = length - 1
    FileSinExtension = Left$(sPathFile, length)
End Function

' Aade ruta si no tiene
' Ejemplo: xxx.flw --> c:\windows\system\xxx.flw
Public Function FileConRuta(sPathFile As String) As String
  'Si ya es absoluta termina
    If InStr(sPathFile, ":\") Or Left$(sPathFile, 1) = "\" Then
        FileConRuta = sPathFile
        Exit Function
    End If

  'Si es relativa la convierte en absoluta
    '1 Toma ruta actual sin "\" terminal
    FileConRuta = CurDir$
    If Right$(FileConRuta, 1) = "\" Then
        FileConRuta = Left$(FileConRuta, Len(FileConRuta) - 1)
    End If
    
    '2 Elimina posible comienzo de nombre de fichero y crea ruta
    If Left$(sPathFile, 2) = ".\" Then
        FileConRuta = FileConRuta & Mid$(sPathFile, 2)
    Else
        FileConRuta = FileConRuta & "\" & sPathFile
    End If
End Function

Public Sub EliminaFile(file As String)
    If FileExist(file) Then
        SetAttr file, vbNormal
        Kill file
    End If
End Sub
'Version case sensitive of FileExist
Public Function FileExistCS(sFilename As String, Optional attributos As VbFileAttribute = vbNormal) As Boolean
Dim s As String
'Prueba con "prn.fsm" devuenve PRN si ni existe tal "prn."
    On Error Resume Next
    s = Dir(sFilename, attributos)
    On Error GoTo 0
    If LenB(s) = 0 Then
        FileExistCS = False
    Else
        FileExistCS = (Right$(sFilename, Len(s)) = s)
    End If
End Function

Public Function FileExist(sFilename As String, Optional attributos As VbFileAttribute = vbNormal) As Boolean
Dim s As String
'Prueba con "prn.fsm" devuenve PRN si ni existe tal "prn."
    On Error Resume Next
    s = Dir(sFilename, attributos)
    On Error GoTo 0
    If LenB(s) = 0 Then
        FileExist = False
    Else
        FileExist = (Right$(UCase$(sFilename), Len(s)) = UCase$(s))
    End If
End Function

'Busca un patrn en directorios y subdirectorios sR(0 ....)
' (Algoritmo de bsqueda en rbol)
Public Sub DirTree(ByVal rutaBase As String, filePatron As String, sR() As String, top As Long)
Dim file As String
Dim attr As Integer
Dim dirs() As String
Dim nDirs As Long
Dim i As Long
    
    rutaBase = rutaBase & "\"
    
    '1 bsqueda de ficheros que cumplan
    file = Dir(rutaBase & filePatron, vbReadOnly)
    Do Until LenB(file) = 0
        file = rutaBase & file
        top = top + 1
        ReDim Preserve sR(1 To top) As String
        sR(top) = file
        file = Dir()
    Loop
    
    '2 Memoriza Subdirectorios
    file = Dir(rutaBase, vbDirectory)
    Do Until LenB(file) = 0
        If file <> "." And file <> ".." Then
            file = rutaBase & file
            attr = GetAttr(file)
            If attr And vbDirectory Then
                nDirs = nDirs + 1
                ReDim Preserve dirs(1 To nDirs) As String
                dirs(nDirs) = file
            End If
        End If
        file = Dir()
    Loop
    
    '3 Tracking de directorios
    For i = 1 To nDirs
        DirTree dirs(i), filePatron, sR(), top
    Next
End Sub
