Attribute VB_Name = "modLib_StringHandling"
Option Explicit

'Change spaces for "_"
Public Function FillSpaces(sToFill As String) As String
Dim i As Long
Dim s As String

    FillSpaces = vbNullString
    For i = 1 To Len(sToFill)
        s = Mid$(sToFill, i, 1)
        If s = " " Then
            FillSpaces = FillSpaces + "_"
        Else
            FillSpaces = FillSpaces + s
        End If
    Next
End Function

'Check if the string is valid like function name or parameter
Public Function ValidString(sToCheck As String) As Boolean
Dim s As String
    ValidString = True
    If LenB(sToCheck) = 0 Then
        ValidString = False
' ElseIf sToCheck Like "*[*?+|!;,-]*" Then ValidString = False
    ElseIf InStr(sToCheck, "*") Then ValidString = False
    ElseIf InStr(sToCheck, "?") Then ValidString = False
    ElseIf InStr(sToCheck, "+") Then ValidString = False
    ElseIf InStr(sToCheck, "-") Then ValidString = False
    ElseIf InStr(sToCheck, "|") Then ValidString = False
    ElseIf InStr(sToCheck, "&") Then ValidString = False
    ElseIf InStr(sToCheck, "!") Then ValidString = False
    ElseIf InStr(sToCheck, ";") Then ValidString = False
    ElseIf InStr(sToCheck, ",") Then ValidString = False
    ElseIf InStr(sToCheck, "/") Then ValidString = False
    'ElseIf InStr(sToCheck, """") Then ValidString = False
    'ElseIf InStr(sToCheck, "#") Then ValidString = False
    'ElseIf InStr(sToCheck, "=") Then ValidString = False
    'ElseIf InStr(sToCheck, ")") Then ValidString = False
    'ElseIf InStr(sToCheck, "(") Then ValidString = False
    Else
        s = Left$(sToCheck, 1)
        If s >= "0" And s <= "9" Then ValidString = False
    End If
End Function

Function SubstTabBySpaces(ByRef s As String, Optional spacesPerTab As Integer = 4) As String
Dim c As String
Dim pos As Long
Dim numEsp As Long
Dim i As Long

    If InStr(s, vbTab) Then
        pos = 0
        For i = 1 To Len(s)
            c = Mid$(s, i, 1) ' Read a character
            Select Case c
                Case vbLf
'                    Debug.Print
'                    Debug.Print "00000000001111111111222222222233333333334444444444555555555566666666667777777777"
'                    Debug.Print "01234567890123456789012345678901234567890123456789012345678901234567890123456789"
                Case vbCr
                    SubstTabBySpaces = SubstTabBySpaces & vbNewLine
                    pos = 0
                Case vbTab
                    numEsp = spacesPerTab - (pos Mod spacesPerTab)
                    pos = pos + numEsp
                    SubstTabBySpaces = SubstTabBySpaces & Space(numEsp)
'                    Debug.Print String(numEsp, "");
                Case Else
                    SubstTabBySpaces = SubstTabBySpaces & c
'                    Debug.Print c;
                    pos = pos + 1
            End Select
        Next
    Else
        SubstTabBySpaces = s
    End If
End Function

Public Function RemoveQuotationMarks(texto As String) As String
    RemoveQuotationMarks = texto
    If Len(texto) >= 2 Then
        If Left$(texto, 1) = Chr$(34) And Right$(texto, 1) = Chr$(34) Then
            RemoveQuotationMarks = Mid$(texto, 2, Len(texto) - 2)
        End If
    End If
End Function

Public Function AddOffset(s As String, offSet As Long) As String
    AddOffset = s
    If offSet > Len(s) Then
        AddOffset = AddOffset & Space$(offSet - Len(s))
    End If
End Function

Public Function Indent(origen As String, nSpaces As Long, Optional bSpaceInitial As Boolean = True) As String
Dim i As Long
Dim s As String

'    Debug.Assert LenB(origen)
    If LenB(origen) Then
        Indent = IIf(bSpaceInitial, Space$(nSpaces), vbNullString)
        For i = 1 To Len(origen)
            s = Mid$(origen, i, 1)
            Select Case s
                Case vbCr
                    Indent = Indent + vbNewLine + Space$(nSpaces)
                Case vbLf
                Case Else
                Indent = Indent + s
            End Select
        Next
        Indent = RTrim$(Indent)
    End If
End Function

Public Function RemoveTrailingCrLf(ByVal s As String) As String
    If LenB(s) Then
        If Right$(s, 1) = vbLf Then
            s = Left$(s, Len(s) - 1)
            If Right$(s, 1) = vbCr Then
                s = Left$(s, Len(s) - 1)
            End If
        End If
        RemoveTrailingCrLf = s
    End If
End Function

Public Function LeadingSpcCrLf(origen As String, nSpaces As Long) As String
Dim s As String
    s = Indent(origen, nSpaces)
    If LenB(s) Then
        If Left$(s, 1) = vbCr Then
            LeadingSpcCrLf = s
        Else
            LeadingSpcCrLf = vbNewLine & s
        End If
        If Right$(s, 1) <> vbLf Then
            LeadingSpcCrLf = LeadingSpcCrLf & vbNewLine
        End If
    Else
        LeadingSpcCrLf = vbNewLine
    End If
    
End Function

' Rethink with Split()
Public Function GetCommandLine(Optional cmdLine As String) As String()
'Declara las variables.
Dim s As String
Dim commandLine As String
Dim lngCmdLine As Integer
Dim bReadingArg As Boolean
Dim i As Integer
Dim numArgs As Integer
ReDim argArray(0 To 0) As String

'    'Crea una matriz del tamao correcto.
'    ReDim ArgArray(MaxArgs) As String
    numArgs = 0
    bReadingArg = False
    'Obtiene los argumentos de la lnea de comandos.
    If LenB(cmdLine) = 0 Then
        cmdLine = Command()
    End If
    
    commandLine = RemoveQuotationMarks(cmdLine)
    lngCmdLine = Len(commandLine)
    'Recorre la lnea de comando carcter a carcter a la vez.
    For i = 1 To lngCmdLine
        s = Mid$(commandLine, i, 1)
        'Comprueba espacio o tabulacin.
        If (s <> " " And s <> vbTab) Then
            'Ningn espacio o tabulacin.
            'Comprueba si est en el argumento.
            If Not bReadingArg Then
                'Empieza el nuevo argumento.
                numArgs = numArgs + 1
                ReDim Preserve argArray(0 To numArgs) As String
                bReadingArg = True
            End If
            'Concatenar el carcter al argumento actual.
            argArray(numArgs) = argArray(numArgs) & s
        Else
            'Encontr un espacio o tabulador.
            'Establece bReadingArg a False.
            bReadingArg = False
        End If
    Next
    'Devuelve la matriz en nombre de la funcin.
    GetCommandLine = argArray()
End Function


'Cambia marcadores C++ a Ansi-C
Public Function MarcadoresAnsiC(origen As String, maxLimit As Long, Optional addCrLf As Boolean = True) As String
Dim i As Long
Dim ch As String
Dim line As String
Dim s As String
    
    For i = 1 To Len(origen)
        ch = Mid$(origen, i, 1)
        Select Case ch
            Case vbCr
                s = s & MarcadorToAnsiC(line, maxLimit) & vbNewLine
                line = vbNullString
                ch = vbNullString
            Case vbLf
                ch = vbNullString
            Case Else
        End Select
        line = line & ch
    Next
    MarcadoresAnsiC = s & MarcadorToAnsiC(line, maxLimit)
    If addCrLf Then MarcadoresAnsiC = MarcadoresAnsiC & vbNewLine
End Function

Private Function MarcadorToAnsiC(line As String, maxLimit As Long) As String
Dim s As String
Dim p As Long
    p = InStr(line, "//")
    If p = 1 Then
        s = "/*" & Mid$(line, p + 2)
        p = maxLimit - Len(s)
        If p < 0 Then p = 0
        s = s & Space$(p) & "*/"
    ElseIf p Then
        If InStrRev(line, "*/") > p Then
            'Avoid:
            '   "/*   //   */"  --> "/*   /*   */*/"
            '   "/*  *//*  */"  --> "/*  */**  */*/"
            s = line
        Else
            s = Left$(line, p - 1) & "/*" & Mid$(line, p + 2) & " */"
        End If
    Else
        s = line
    End If
MarcadorToAnsiC = s
End Function
